C -----------------------------------------------------------------------------
      SUBROUTINE ZadaneZico(part,xpi)
C
C -----------------------------------------------------------------------------
      INCLUDE 'inc_types.f'

      TYPE(particleType) :: part
      REAL(8) xpi

      INTEGER n,i,j
      REAL(8) x0,z0,dist,r0

      r0=0.005D0 ! cca velikost mrezne celice pri mrezi 75x1x75

      n=INT(xpi+0.1D0)
      DO i=1,n
        DO j=1,n
          x0=(2*i-1)/DBLE(2*n)
          z0=(2*j-1)/DBLE(2*n)
          dist=SQRT( (part%x-x0)**2 + (part%z-z0)**2 )
          IF (dist.LT.r0.AND.part%still.EQ..FALSE.) THEN
c            print *,"WWW",part%x,part%z,x0,z0,dist
            part%x=x0
            part%z=z0
            part%vx=0.0D0
            part%vy=0.0D0
            part%vz=0.0D0
            part%vsx=0.0D0
            part%vsy=0.0D0
            part%vsz=0.0D0
            part%still=.TRUE.
          END IF
        END DO
      END DO

      END


C -----------------------------------------------------------------------------
      SUBROUTINE RazdaljaDoNajblizjeZice(part,xpi,mdist)
C
C -----------------------------------------------------------------------------
      INCLUDE 'inc_types.f'

      TYPE(particleType) :: part
      REAL(8) xpi

      INTEGER n,i,j
      REAL(8) x0,z0,dist,mdist


      n=INT(xpi+0.1D0)
      DO i=1,n
        DO j=1,n
          x0=(2*i-1)/DBLE(2*n)
          z0=(2*j-1)/DBLE(2*n)
          dist=SQRT( (part%x-x0)**2 + (part%z-z0)**2 )
          IF (dist.LT.mdist) mdist=dist
        END DO
      END DO

      END

C -----------------------------------------------------------------------------
      SUBROUTINE SetUpMagField(mesh,cpd,mmodel,xpi,mfs,nhh,inp)
C
C -----------------------------------------------------------------------------
      INCLUDE 'inc_types.f'
      TYPE(meshType) :: mesh
      TYPE(CommonParticleDataType) :: cpd  ! common particle data
      TYPE(InputType) inp
      INTEGER mmodel,i
      REAL(8) mfs(mesh%nnodes,3)
      REAL(8) nhh(mesh%nnodes,3)
      REAL(8) tmp(mesh%nnodes)
      REAL(8) pi,mu0
      REAL(8) alfa,xpi,h,hip

      INTEGER n,n2,j,k
      REAL(8) x0,z0,r02,x,z,predznak,y,y0,M

C     magnetic factor
      pi=4.0D0*DATAN(1.0D0)
      mu0=4.0D0*pi*0.0000001D0

      IF (mmodel.EQ.1) THEN     ! izmisljeno - neumnost
        cpd%mfac=mu0*(cpd%p_hi-cpd%f_hi)*cpd%H0**2 / (2.0D0 * cpd%f_u0**2 * cpd%p_rho)
        DO i=1,mesh%nnodes
          mfs(i,1)=sin(pi*mesh%x(i,1))
          mfs(i,2)=0.0D0
          mfs(i,3)=sin(pi*mesh%x(i,3))
        END DO
C       do scalar product  \vec H \cdot \vec H
        DO i=1,mesh%nnodes
          tmp(i)=cpd%mfac*(mfs(i,1)**2+mfs(i,2)**2+mfs(i,3)**2)
        END DO
C       \nabla tmp
        CALL setGRAD(mesh,tmp,nhh)
      ELSE IF (mmodel.EQ.2) THEN  ! long thin wire
        cpd%mfac=-mu0*(cpd%p_hi-cpd%f_hi)*cpd%H0**2 / (cpd%f_u0**2 * cpd%p_rho)
c       v tem primeru je H_0^2=(L*I^2)/(4pi^2r_0^3)
c       veljati mora r_0>>L, i.e. r_0^3/L je vsaj 1000.
c       spremenim smer toka I
        cpd%mfac=ABS(cpd%mfac)
        mfs=-9.9D0
        alfa=45.0d0 ! kot med gravitacijo in magnetnim pospeskom.
        DO i=1,mesh%nnodes
          nhh(i,1)=cpd%mfac*sin(pi*alfa/180.0D0)
          nhh(i,2)=0.0D0
          nhh(i,3)=-cpd%mfac*cos(pi*alfa/180.0D0)
        END DO
      ELSE IF (mmodel.EQ.3) THEN    ! vec zic skupaj ! xpi je stevilo celic
        mfs=0.0D0
        n=INT(2.0D0*xpi-1.0D0+0.1D0)
        n2=n*n
        DO i=1,n
          DO j=1,n
            x0=(i-1)/DBLE(n-1)
            z0=(j-1)/DBLE(n-1)
            IF (MOD(i+j,2).EQ.0) THEN ! sodo
              predznak=-1.0D0
            ELSE ! liho
              predznak=1.0D0
            END IF
            DO k=1,mesh%nnodes
              x=mesh%x(k,1)
              z=mesh%x(k,3)
              r02=(x-x0)**2+(z-z0)**2
              IF (r02.LT.0.001D0) THEN
                r02=0.001D0
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak
              ELSE
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak
              END IF
c              if (k.eq.3044) print *,mfs(k,1),mfs(k,3),"w",r02,z-z0,x-x0
            END DO
          END DO
        END DO
        ! H0 = I^2 / 4pi^2
        cpd%mfac=mu0*(cpd%p_hi-cpd%f_hi)*cpd%H0**2 / (2.0D0 * cpd%f_u0**2 * cpd%p_rho)
C       do scalar product  \vec H \cdot \vec H
        DO i=1,mesh%nnodes
          tmp(i)=cpd%mfac*(mfs(i,1)**2+mfs(i,2)**2+mfs(i,3)**2)
        END DO
C       \nabla tmp
        CALL setGRAD(mesh,tmp,nhh)
      ELSE IF (mmodel.EQ.4) THEN    ! vec zic skupaj ! xpi je stevilo celic
        mfs=0.0D0
        n=INT(xpi+0.1D0)*8
        n2=n*n
        DO i=1,n
          DO j=1,n
            x0=(2*i-n-1)/DBLE(n/4)
            z0=(2*j-n-1)/DBLE(n/4)
            IF (MOD(i+j,2).EQ.0) THEN ! sodo
              predznak=-1.0D0
            ELSE ! liho
              predznak=1.0D0
            END IF
            DO k=1,mesh%nnodes
              x=mesh%x(k,1)
              z=mesh%x(k,3)
              r02=(x-x0)**2+(z-z0)**2
              IF (r02.EQ.0.0D0) THEN
                r02=0.001D0
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak
                print *,"EEEEEEE"
              ELSE
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak
              END IF
c              if (k.eq.3044) print *,mfs(k,1),mfs(k,3),"w",r02,z-z0,x-x0
            END DO
          END DO
        END DO
        ! H0 = I / 4pi L
        cpd%mfac=mu0*(cpd%p_hi-cpd%f_hi)*cpd%H0**2 / (2.0D0 * cpd%f_u0**2 * cpd%p_rho)
C       do scalar product  \vec H \cdot \vec H
        DO i=1,mesh%nnodes
          tmp(i)=cpd%mfac*(mfs(i,1)**2+mfs(i,2)**2+mfs(i,3)**2)
        END DO
C       \nabla tmp
        CALL setGRAD(mesh,tmp,nhh) ! to dela slabo

      ELSE IF (mmodel.EQ.5.OR.mmodel.EQ.6) THEN    ! vec zic skupaj ! xpi je stevilo celic
        ! H0 = I / 2 pi L
        cpd%mfac=mu0*(cpd%p_hi-cpd%f_hi)*cpd%H0**2 / (cpd%f_u0**2 * cpd%p_rho)
        mfs=0.0D0
        nhh=0.0D0
        n=INT(xpi+0.1D0)*8
        n2=n*n
        DO i=1,n
          DO j=1,n
            x0=(2*i-n-1)/DBLE(n/4)
            z0=(2*j-n-1)/DBLE(n/4)
            IF (MOD(i+j,2).EQ.0) THEN ! sodo
              predznak=-1.0D0
            ELSE ! liho
              predznak=1.0D0
            END IF
            DO k=1,mesh%nnodes
              x=mesh%x(k,1)
              z=mesh%x(k,3)
              r02=(x-x0)**2+(z-z0)**2
              IF (r02.EQ.0.0D0) THEN
                r02=0.001D0
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak
                nhh(k,1)=nhh(k,1)-(x-x0)/r02**2*cpd%mfac
                nhh(k,2)=0.0D0
                nhh(k,3)=nhh(k,3)-(z-z0)/r02**2*cpd%mfac
                print *,"PAZI, MREZNA TOCKA TOCNO V ZICI !!!!!!"
              ELSE
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak

                nhh(k,1)=nhh(k,1)-(x-x0)/r02**2*cpd%mfac
                nhh(k,2)=0.0D0
                nhh(k,3)=nhh(k,3)-(z-z0)/r02**2*cpd%mfac
              END IF
            END DO
          END DO
        END DO


      ELSE IF (mmodel.EQ.7) THEN    ! ena zica na 0.5, 0.5
        ! H0 = I / 2 pi L
        cpd%mfac=mu0*(cpd%p_hi-cpd%f_hi)*cpd%H0**2 / (cpd%f_u0**2 * cpd%p_rho)
        mfs=0.0D0
        nhh=0.0D0
        print *,"JJJJJJJJJJ"
            x0=0.5001D0 
            z0=0.5001D0 
            DO k=1,mesh%nnodes
              x=mesh%x(k,1)
              z=mesh%x(k,3)
              r02=(x-x0)**2+(z-z0)**2
              IF (r02.EQ.0.0D0) THEN
                r02=0.001D0
                mfs(k,1)=mfs(k,1)-(z-z0)/r02
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02
                nhh(k,1)=nhh(k,1)-(x-x0)/r02**2
                nhh(k,2)=0.0D0
                nhh(k,3)=nhh(k,3)-(z-z0)/r02**2
                print *,"PAZI, MREZNA TOCKA TOCNO V ZICI !!!!!!"
              ELSE
                mfs(k,1)=mfs(k,1)-(z-z0)/r02
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02

                nhh(k,1)=nhh(k,1)-(x-x0)/r02**2*cpd%mfac
                nhh(k,2)=0.0D0
                nhh(k,3)=nhh(k,3)-(z-z0)/r02**2*cpd%mfac
              END IF
            END DO

      ELSE IF (mmodel.EQ.8) THEN    ! vec zic skupaj
        ! H0 = I / 2 pi L
        cpd%mfac=mu0*(cpd%p_hi-cpd%f_hi)*cpd%H0**2 / (cpd%f_u0**2 * cpd%p_rho)
        mfs=0.0D0
        nhh=0.0D0
        DO i=1,inp%nwire
          x0=inp%wireX(i)
          z0=inp%wireZ(i)
          predznak=inp%wireSign(i)
            DO k=1,mesh%nnodes
              x=mesh%x(k,1)
              z=mesh%x(k,3)
              r02=(x-x0)**2+(z-z0)**2
              IF (r02.EQ.0.0D0) THEN
                r02=0.001D0
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak
                nhh(k,1)=nhh(k,1)-(x-x0)/r02**2*cpd%mfac
                nhh(k,2)=0.0D0
                nhh(k,3)=nhh(k,3)-(z-z0)/r02**2*cpd%mfac
                print *,"PAZI, MREZNA TOCKA TOCNO V ZICI !!!!!!"
              ELSE
                mfs(k,1)=mfs(k,1)-(z-z0)/r02*predznak
                mfs(k,2)=0.0D0
                mfs(k,3)=mfs(k,3)+(x-x0)/r02*predznak

                nhh(k,1)=nhh(k,1)-(x-x0)/r02**2*cpd%mfac
                nhh(k,2)=0.0D0
                nhh(k,3)=nhh(k,3)-(z-z0)/r02**2*cpd%mfac
              END IF
            END DO
        END DO

      ELSE IF (mmodel.EQ.9) THEN    ! vec zic skupaj smer Y,Z
        ! H0 = I / 2 pi L
        cpd%mfac=mu0*cpd%H0**2 / (cpd%f_u0**2 * cpd%p_rho)
        mfs=0.0D0
        nhh=0.0D0
        DO i=1,inp%nwire
          y0=inp%wireX(i)
          z0=inp%wireZ(i)
          predznak=inp%wireSign(i)
            DO k=1,mesh%nnodes
              y=mesh%x(k,2)
              z=mesh%x(k,3)
              r02=(y-y0)**2+(z-z0)**2
              IF (r02.EQ.0.0D0) THEN
                r02=0.001D0
                print *,"PAZI, MREZNA TOCKA TOCNO V ZICI !!!!!!"
              END IF
              mfs(k,1)=0.0D0
              mfs(k,2)=mfs(k,2)+(z-z0)/r02*predznak
              mfs(k,3)=mfs(k,3)-(y-y0)/r02*predznak

              nhh(k,1)=0.0D0
              nhh(k,2)=nhh(k,2)-(y-y0)/r02**2*cpd%mfac
              nhh(k,3)=nhh(k,3)-(z-z0)/r02**2*cpd%mfac
            END DO
        END DO
c       dodam razliko susceptibilnosti
        DO k=1,mesh%nnodes
          h=cpd%H0*SQRT(mfs(k,1)**2+mfs(k,2)**2+mfs(k,3)**2)
          CALL CalMagnetiteSusc(h,hip)
          nhh(k,1)=nhh(k,1)*(hip-cpd%f_hi)
          nhh(k,2)=nhh(k,2)*(hip-cpd%f_hi)
          nhh(k,3)=nhh(k,3)*(hip-cpd%f_hi)
        END DO

      ELSE IF (mmodel.EQ.10) THEN    ! vec zic skupaj smer Y,Z, namagneteno prek permanentnega magneta
        ! H0 = iz permanentnega magneta
        CALL CalWireMagnetization(cpd%H0,M)
c        print *,cpd%H0,M,(M+cpd%H0)*mu0
c        stop
        cpd%mfac=mu0/ (cpd%f_u0**2 * cpd%p_rho) * 0.1245D0 ! delez magnetita v delcu
        mfs=0.0D0
        nhh=0.0D0
        DO k=1,mesh%nnodes
          mfs(k,3)=cpd%H0
        END DO
        DO i=1,inp%nwire
          inp%wr=inp%wireSign(i) ! za model 10 uporabim wiresign za vnos polmera zice
          y0=inp%wireX(i)
          z0=inp%wireZ(i)
            DO k=1,mesh%nnodes
              y=mesh%x(k,2)
              z=mesh%x(k,3)
              r02=(y-y0)**2+(z-z0)**2
              IF (sqrt(r02).LT.inp%wr) THEN
                print *,"PAZI, TOK ZNOTRAJ ZICE"
              END IF
              mfs(k,1)=0.0D0
              mfs(k,2)=mfs(k,2)+M*inp%wr**2*(y-y0)*(z-z0)/r02**2
              mfs(k,3)=mfs(k,3)+0.5D0*M*inp%wr**2*( (z-z0)**2 - (y-y0)**2 ) / r02**2

              nhh(k,1)=0.0D0
              nhh(k,2)=nhh(k,2)-0.5D0*M*(inp%wr**2)/r02**3*(y-y0)*(M*(inp%wr**2)-2.0D0*cpd%H0*(y-y0)**2+6.0D0*cpd%H0*(z-z0)**2)
              nhh(k,3)=nhh(k,3)-0.5D0*M*(inp%wr**2)/r02**3*(z-z0)*(M*(inp%wr**2)-6.0D0*cpd%H0*(y-y0)**2+2.0D0*cpd%H0*(z-z0)**2)
            END DO
        END DO
c       dodam razliko susceptibilnosti
        DO k=1,mesh%nnodes
          h=SQRT(mfs(k,1)**2+mfs(k,2)**2+mfs(k,3)**2)
          CALL CalMagnetiteSusc(h,hip)
          nhh(k,1)=nhh(k,1)*(hip-cpd%f_hi)*cpd%mfac
          nhh(k,2)=nhh(k,2)*(hip-cpd%f_hi)*cpd%mfac
          nhh(k,3)=nhh(k,3)*(hip-cpd%f_hi)*cpd%mfac
        END DO


      ELSE
        mfs=0.0D0
        cpd%mfac=0.0D0
        nhh=0.0D0
      END IF

c      DO i=1,mesh%nnodes
c        print *,mesh%x(i,1),nhh(i,1),nhh(i,2),nhh(i,3)
c      END DO
c      stop
      END

C -----------------------------------------------------------------------------
      SUBROUTINE wMagFieldTec(mesh,mfs,nhh)
C
C     $: zapise magnetic field na disk
C
C -----------------------------------------------------------------------------
      INCLUDE 'inc_types.f'

      TYPE(meshType)  :: mesh
      REAL(8) mfs(mesh%nnodes,3)
      REAL(8) nhh(mesh%nnodes,3)

      CHARACTER*200 vrstica

      INTEGER itp,nic,i

      itp=77
      nic=8*mesh%nicell
      OPEN (itp,FILE="magnetic.dat",STATUS='UNKNOWN')

      WRITE (itp,'(A)') 'VARIABLES = "X", "Y", "Z", "node","Hx","Hy","Hz","fac*NHHx","fac*NHHy","fac*NHHz"'

      WRITE (itp,'(A,I8,A,I8)')
     &      'ZONE T="cell flow field",F=FEPOINT, ET=BRICK,N= ', mesh%NNODES, ',E=', nic

C       Output results
        DO  i=1,mesh%nnodes
          WRITE (vrstica,'(3G18.9,I8,6G18.9)')
     &        mesh%x(i,1),mesh%x(i,2),mesh%x(i,3),i,
     &        mfs(i,1),mfs(i,2),mfs(i,3),
     &        nhh(i,1),nhh(i,2),nhh(i,3)

          CALL sqblnk(itp,vrstica)
        END DO
        CALL TECwIDC(itp,mesh)

      CLOSE(itp)

      END

C -----------------------------------------------------------------------------
      SUBROUTINE CalMagnetiteSusc(Hval,hiVal)
C
C     $: Izracuna susceptibilniost na podlagi grafa iz clanka Chen et al. 2008,
C        glej tudi D15, ods datoteko.
C
C -----------------------------------------------------------------------------
      REAL(8) Hval, hiVal
      REAL(8), ALLOCATABLE :: H(:),hi(:)
      INTEGER n,i

      n=13
      ALLOCATE (hi(n),H(n))

      H(1)=0.0000000000D0
      H(2)=15303.3630964565D0
      H(3)=28693.8058058560D0
      H(4)=61213.4523858261D0
      H(5)=109036.4620622530D0
      H(6)=168336.9940610220D0
      H(7)=369193.6347020140D0
      H(8)=593005.3199876910D0
      H(9)=786210.2790804540D0
      H(10)=7862102.7908045400D0
      H(11)=78621027.9080454000D0
      H(12)=786210279.0804540000D0
      H(13)=7862102790.8045400000D0

      hi(1)=0.5556393475D0
      hi(2)=0.5556393475D0
      hi(3)=0.3820594521D0
      hi(4)=0.2158268540D0
      hi(5)=0.1327669486D0
      hi(6)=0.0897539141D0
      hi(7)=0.0433985428D0
      hi(8)=0.0274931119D0
      hi(9)=0.0209156634D0
      hi(10)=0.0020915663D0
      hi(11)=0.0002091566D0
      hi(12)=0.0000209157D0
      hi(13)=0.0000020916D0


      DO i=1,n-1
        IF (Hval.GE.H(i).AND.Hval.LE.H(i+1)) THEN
c         interpoliram znotraj intervala
          hiVal=hi(i)+( hi(i+1) - hi(i)  ) / ( H(i+1) - H(i) ) * (Hval - H(i) )
          EXIT
        END IF
      END DO


      DEALLOCATE (hi,H)

      END


C -----------------------------------------------------------------------------
      SUBROUTINE CalWireMagnetization(Hval,Mval)
C
C     $: Izracuna M iz H na podlagi grafa iz clanka Chen et al. 2008,
C        glej tudi D15, ods datoteko.
C
C -----------------------------------------------------------------------------
      REAL(8) Hval, Mval
      REAL(8), ALLOCATABLE :: H(:),M(:)
      INTEGER n,i

      n=13
      ALLOCATE (M(n),H(n))


      h(1)=0D0
      h(2)=83380.82D0
      h(3)=137505.22D0
      h(4)=163836D0
      h(5)=182852.68D0
      h(6)=206257.83D0
      h(7)=241365.54D0
      h(8)=296952.76D0
      h(9)=373019.48D0
      h(10)=513450.34D0
      h(11)=690451.73D0
      h(12)=792849.24D0
      h(13)=792849240000D0

      m(1)=0D0
      m(2)=641422.02D0
      m(3)=945825.69D0
      m(4)=1061788.99D0
      m(5)=1123394.5D0
      m(6)=1156009.17D0
      m(7)=1206743.12D0
      m(8)=1257477.06D0
      m(9)=1308211.01D0
      m(10)=1344449.54D0
      m(11)=1366192.66D0
      m(12)=1373440.37D0
      m(13)=1373440.37D0





      DO i=1,n-1
        IF (Hval.GE.H(i).AND.Hval.LE.H(i+1)) THEN
c         interpoliram znotraj intervala
          MVal=m(i)+( m(i+1) - m(i)  ) / ( H(i+1) - H(i) ) * (Hval - H(i) )
          EXIT
        END IF
      END DO


      DEALLOCATE (M,H)

      END

