      SUBROUTINE funcs(x,a,y,dyda,ma,model)

      INTEGER ma,MMAX,model
      PARAMETER (MMAX=20)
      REAL(8) x,a(ma),y,dyda(MMAX)
      REAL(8) tmp,ltmp

      IF (model.EQ.1) THEN
C       premica
        y=a(1)*x+a(2)

        dyda(1)=x
        dyda(2)=1.0D0
      ELSE IF (model.EQ.2) THEN
C       parabola
        y=a(1)*x**2+a(2)*x+a(3)

        dyda(1)=x**2
        dyda(2)=x
        dyda(3)=1.0D0
      ELSE IF (model.EQ.3) THEN
C       sigmoida
        tmp=(a(2)/(x-40))**a(3)
        ltmp=DLog(a(2)/(x-40))

        y=a(1) / ( 1.0D0 + tmp ) + a(4)

        dyda(1)=1.0D0 / ( 1.0D0 + tmp )
        dyda(2)=- a(1)*a(3)*tmp / (a(2)*(1.0D0+tmp)**2)
        dyda(3)=- a(1)*tmp*ltmp / (1.0D0+tmp)**2
        dyda(4)=1.0D0

      ELSE IF (model.EQ.4) THEN
C       exp
        tmp=EXP(-a(3)*(x+a(4)))

        y=a(1)+( a(2)-a(1) )*tmp

        dyda(1)=1.0D0-tmp
        dyda(2)=tmp
        dyda(3)=(a(1)-a(2))*(x+a(4))*tmp
        dyda(4)=(a(1)-a(2))*a(3)*tmp

      ELSE IF (model.EQ.5) THEN
C       A*(1-exp(-B*x))
        tmp=EXP(-a(2)*x)

        y=a(1)*(1.0D0-tmp)

        dyda(1)=1.0D0-tmp
        dyda(2)=a(1)*x*tmp


      END IF

      END


      SUBROUTINE TESTfitparabola

      INTEGER ndata,ma,nca,i,j,n,model
      REAL(8), ALLOCATABLE :: x(:),y(:),sig(:),a(:),covar(:,:),alpha(:,:),ap(:)
      INTEGER, ALLOCATABLE :: ia(:)
      REAL(8) alamda,chisq
      REAL(8) res,res1

      ndata=5
      ma=3
      nca=3
      ALLOCATE (x(ndata),y(ndata),sig(ndata))
      ALLOCATE (ia(ma))
      ALLOCATE (a(ma),ap(ma),alpha(nca,nca),covar(nca,nca))

C     TEST PREMICE
      ia(1)=1
      ia(2)=1

      ap=-100.0D0
      a(1)=1.0D0
      a(2)=1.0D0
      a(3)=1.0D0

      model=2
      DO i=1,ndata
        x(i)=DBLE(i)
        y(i)=5.0D0*x(i)**2+3.0D0*x(i)+17.0D0
        sig(i)=1.0D0
      END DO

      alamda=-1.0D0
      res=1.0D0
      n=0
      DO WHILE (res.GT.1.0D-6.AND.n.LT.101)
        ap=a
        n=n+1
        CALL mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,alamda,model)
        print *,alamda,a(1),a(2),a(3)
        res=0.0D0
        res1=0.0D0
        DO j=1,ma
          res=res+(ap(j)-a(j))**2
          res1=res1+a(j)**2
        END DO
        IF (res1.NE.0.0D0) res=res/res1
        print *,res
      END DO
      alamda=0.0D0
      CALL mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,alamda,model)
      print *,n,a(1),a(2),a(3)

      END


      SUBROUTINE TESTfitpremica

      INTEGER ndata,ma,nca,i,j,n,model
      REAL(8), ALLOCATABLE :: x(:),y(:),sig(:),a(:),covar(:,:),alpha(:,:),ap(:)
      INTEGER, ALLOCATABLE :: ia(:)
      REAL(8) alamda,chisq
      REAL(8) res,res1

      ndata=50
      ma=2
      nca=2
      ALLOCATE (x(ndata),y(ndata),sig(ndata))
      ALLOCATE (ia(ma))
      ALLOCATE (a(ma),ap(ma),alpha(nca,nca),covar(nca,nca))

C     TEST PREMICE
      ia(1)=1
      ia(2)=1

      ap=-100.0D0
      a(1)=1.0D0
      a(2)=1.0D0

      model=1
      DO i=1,ndata
        x(i)=DBLE(i)
        y(i)=-5.0D0*x(i)+3.0D0
        sig(i)=1.0D0
      END DO

      alamda=-1.0D0
      res=1.0D0
      n=0
      DO WHILE (res.GT.1.0D-6.AND.n.LT.101)
        ap=a
        n=n+1
        CALL mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,alamda,model)
c        print *,alamda,a(1),a(2)
        res=0.0D0
        res1=0.0D0
        DO j=1,ma
          res=res+(ap(j)-a(j))**2
          res1=res1+a(j)**2
        END DO
        IF (res1.NE.0.0D0) res=res/res1
        print *,n,res
      END DO
      alamda=0.0D0
      CALL mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,alamda,model)
      print *,n,a(1),a(2)

      END



      SUBROUTINE mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,alamda,model)

C     ndata     stevilo podatkov
C     ma        stevilo parametrov
C     nca >= ma = ma
C     x(ndata)  Temperature
C     y(ndata)  Poraba plina
C     sig(ndata) sigme
C     model - izbor katero funkcijo fitam (glej subroutine funcs)



      INTEGER ma,nca,ndata,ia(ma),MMAX
      REAL(8) alamda,chisq,a(ma),alpha(nca,nca),covar(nca,nca),
     *sig(ndata),x(ndata),y(ndata)
      PARAMETER (MMAX=20)
CU    USES covsrt,gaussj,mrqcof
      INTEGER j,k,l,m,mfit,model
      REAL(8) ochisq,atry(MMAX),beta(MMAX),da(MMAX)
      SAVE ochisq,atry,beta,da,mfit
      if(alamda.lt.0.)then
        mfit=0
        do 11 j=1,ma
          if (ia(j).ne.0) mfit=mfit+1
11      continue
        alamda=0.001D0
        call mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nca,chisq,model)
        ochisq=chisq
        do 12 j=1,ma
          atry(j)=a(j)
12      continue
      endif
      j=0
      do 14 l=1,ma
        if(ia(l).ne.0) then
          j=j+1
          k=0
          do 13 m=1,ma
            if(ia(m).ne.0) then
              k=k+1
              covar(j,k)=alpha(j,k)
            endif
13        continue
          covar(j,j)=alpha(j,j)*(1.0D0+alamda)
          da(j)=beta(j)
        endif
14    continue
      call gaussj(covar,mfit,nca,da,1,1)
      if(alamda.eq.0.)then
        call covsrt(covar,nca,ma,ia,mfit)
        return
      endif
      j=0
      do 15 l=1,ma
        if(ia(l).ne.0) then
          j=j+1
          atry(l)=a(l)+da(j)
        endif
15    continue
      call mrqcof(x,y,sig,ndata,atry,ia,ma,covar,da,nca,chisq,model)
      if(chisq.lt.ochisq)then
        alamda=0.1D0*alamda
        ochisq=chisq
        j=0
        do 17 l=1,ma
          if(ia(l).ne.0) then
            j=j+1
            k=0
            do 16 m=1,ma
              if(ia(m).ne.0) then
                k=k+1
                alpha(j,k)=covar(j,k)
              endif
16          continue
            beta(j)=da(j)
            a(l)=atry(l)
          endif
17      continue
      else
        alamda=10.0D0*alamda
        chisq=ochisq
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *5ji6.)+.

      SUBROUTINE gaussj(a,n,np,b,m,mp)
      INTEGER m,mp,n,np,NMAX
      REAL(8) a(np,np),b(np,mp)
      PARAMETER (NMAX=50)
      INTEGER i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
      REAL(8) big,dum,pivinv
      do 11 j=1,n
        ipiv(j)=0
11    continue
      do 22 i=1,n
        big=0.
        do 13 j=1,n
          if(ipiv(j).ne.1)then
            do 12 k=1,n
              if (ipiv(k).eq.0) then
                if (abs(a(j,k)).ge.big)then
                  big=abs(a(j,k))
                  irow=j
                  icol=k
                endif
              else if (ipiv(k).gt.1) then
                print *, 'singular matrix in gaussj'
              endif
12          continue
          endif
13      continue
        ipiv(icol)=ipiv(icol)+1
        if (irow.ne.icol) then
          do 14 l=1,n
            dum=a(irow,l)
            a(irow,l)=a(icol,l)
            a(icol,l)=dum
14        continue
          do 15 l=1,m
            dum=b(irow,l)
            b(irow,l)=b(icol,l)
            b(icol,l)=dum
15        continue
        endif
        indxr(i)=irow
        indxc(i)=icol
        if (a(icol,icol).eq.0.) print *, 'singular matrix in gaussj'
        pivinv=1./a(icol,icol)
        a(icol,icol)=1.
        do 16 l=1,n
          a(icol,l)=a(icol,l)*pivinv
16      continue
        do 17 l=1,m
          b(icol,l)=b(icol,l)*pivinv
17      continue
        do 21 ll=1,n
          if(ll.ne.icol)then
            dum=a(ll,icol)
            a(ll,icol)=0.
            do 18 l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
18          continue
            do 19 l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
19          continue
          endif
21      continue
22    continue
      do 24 l=n,1,-1
        if(indxr(l).ne.indxc(l))then
          do 23 k=1,n
            dum=a(k,indxr(l))
            a(k,indxr(l))=a(k,indxc(l))
            a(k,indxc(l))=dum
23        continue
        endif
24    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *5ji6.)+.


      SUBROUTINE mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nalp,chisq,model)
      INTEGER ma,nalp,ndata,ia(ma),MMAX,model
      REAL(8) chisq,a(ma),alpha(nalp,nalp),beta(ma),sig(ndata),x(ndata),
     *y(ndata)
      PARAMETER (MMAX=20)
      INTEGER mfit,i,j,k,l,m
      REAL(8) dy,sig2i,wt,ymod,dyda(MMAX)
      mfit=0
      do 11 j=1,ma
        if (ia(j).ne.0) mfit=mfit+1
11    continue
      do 13 j=1,mfit
        do 12 k=1,j
          alpha(j,k)=0.
12      continue
        beta(j)=0.
13    continue
      chisq=0.
      do 16 i=1,ndata
        call funcs(x(i),a,ymod,dyda,ma,model)
        sig2i=1./(sig(i)*sig(i))
        dy=y(i)-ymod
        j=0
        do 15 l=1,ma
          if(ia(l).ne.0) then
            j=j+1
            wt=dyda(l)*sig2i
            k=0
            do 14 m=1,l
              if(ia(m).ne.0) then
                k=k+1
                alpha(j,k)=alpha(j,k)+wt*dyda(m)
              endif
14          continue
            beta(j)=beta(j)+dy*wt
          endif
15      continue
        chisq=chisq+dy*dy*sig2i
16    continue
      do 18 j=2,mfit
        do 17 k=1,j-1
          alpha(k,j)=alpha(j,k)
17      continue
18    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *5ji6.)+.


      SUBROUTINE covsrt(covar,npc,ma,ia,mfit)
      INTEGER ma,mfit,npc,ia(ma)
      REAL(8) covar(npc,npc)
      INTEGER i,j,k
      REAL(8) swap
      do 12 i=mfit+1,ma
        do 11 j=1,i
          covar(i,j)=0.
          covar(j,i)=0.
11      continue
12    continue
      k=mfit
      do 15 j=ma,1,-1
        if(ia(j).ne.0)then
          do 13 i=1,ma
            swap=covar(i,k)
            covar(i,k)=covar(i,j)
            covar(i,j)=swap
13        continue
          do 14 i=1,ma
            swap=covar(k,i)
            covar(k,i)=covar(j,i)
            covar(j,i)=swap
14        continue
          k=k-1
        endif
15    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *5ji6.)+.

