C -----------------------------------------------------------------------------
      SUBROUTINE GetNextPartNo(n,nproc)
C
C     $: poveca stevilo n do nproc, ce ne ena
C
C -----------------------------------------------------------------------------
      INTEGER n,nproc

      IF (n.EQ.nproc) THEN
        n=1
      ELSE
        n=n+1
      END IF

      END


C -----------------------------------------------------------------------------
      SUBROUTINE par_init(env)
C
C     $: Init parallel environment
C
C -----------------------------------------------------------------------------
      INCLUDE 'inc_types.f'
      INTEGER ierr
      TYPE(penv) :: env

      ierr=0

      env%comm = MPI_COMM_WORLD
      CALL MPI_INIT(ierr)
      CALL MPI_COMM_SIZE(env%comm,env%nproc,ierr)
      CALL MPI_COMM_RANK(env%comm,env%mpr,ierr)
      env%myproc = env%mpr+1

      IF (ierr.NE.0) THEN
        WRITE (*,*) "Could not init parallel environment!!"
      END IF

      END


C -----------------------------------------------------------------------------
      SUBROUTINE StopProgram(env,io,inp,ierr)
C
C     $: stops excecution of the programm
C
C -----------------------------------------------------------------------------
      INCLUDE 'inc_types.f'
      TYPE(IOtype) :: io
      TYPE(InputType) :: inp
      TYPE(penv) :: env
      INTEGER ierr

      IF (env%myproc.EQ.1) THEN
        CALL DatumInUra(inp%endtime)
        WRITE (io%l,'(//A,A)') "START:",inp%StartTime
        WRITE (io%l,'(A,A)') "END  :",inp%EndTime
        IF (ierr.NE.0) THEN
          WRITE (io%l,'(/A)') "Finished with an error!"
        ELSE
          WRITE (io%l,'(/A)') "Exited normally!"
        END IF
        CLOSE(io%l)
c       error/warning file
        CLOSE (io%errwarn)
c       monitor foce files
        CLOSE (io%imf)
      END IF

      CALL MPI_FINALIZE(env%comm,ierr)
      STOP
      END
