C -----------------------------------------------------------------------------
      SUBROUTINE rk4(y,dydx,n,x,h,yout,pn,part,cpd,fap)

      INCLUDE 'inc_types.f'      
      INTEGER n,i
      REAL*8 h,x,dydx(n),y(n),yout(n)
      REAL*8 h6,hh,xh,dym(n),dyt(n),yt(n)

      TYPE(fluidAtPartType) :: fap ! tekocina na mestu delca
      TYPE(CommonParticleDataType) :: cpd  ! common particle data
      TYPE(particleType) :: part(cpd%maxNp) ! seznam delcev       
      INTEGER pn ! particle number

      hh=h*0.5
      h6=h/6.
      xh=x+hh
      do 11 i=1,n
        yt(i)=y(i)+hh*dydx(i)
11    continue

      call cal_dvdt(pn,part,cpd,fap,yt,dyt)
      do 12 i=1,n
        yt(i)=y(i)+hh*dyt(i)
12    continue
      call cal_dvdt(pn,part,cpd,fap,yt,dym)
      do 13 i=1,n
        yt(i)=y(i)+h*dym(i)
        dym(i)=dyt(i)+dym(i)
13    continue
      call cal_dvdt(pn,part,cpd,fap,yt,dyt)
      do 14 i=1,n
        yout(i)=y(i)+h6*(dydx(i)+dyt(i)+2.*dym(i))
14    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *5ji6.)+.    








c***********************************************************************
c***********************************************************************
c***********************************************************************
c***********************************************************************


      SUBROUTINE test3g
      REAL(8), ALLOCATABLE :: y(:),yout(:),dydx(:)
      INTEGER n,i
      REAL(8) x,h,a
c      d2y/dx2=a
      WRITE (*,*) "Resitev enacbe d2y/dx2=a od 0 do 2"
      n=6
      ALLOCATE (y(n),yout(n),dydx(n))
      x=0.0D00  ! cas
      h=0.01D0    ! delta t
      a=1.0D0       ! pospesek [m/s^2]

c     robni pogoji      
      y(1)=0.0D00 ! zacetni polozaj x
      y(2)=0.0D00 ! zacetna hitrost x
      y(3)=0.0D00 ! zacetni polozaj y
      y(4)=0.0D00 ! zacetna hitrost y
      y(5)=0.0D00 ! zacetni polozaj z
      y(6)=0.0D00 ! zacetna hitrost z

      WRITE (*,*) x,y(1),y(2),y(3),y(4),y(5),y(6)
      
      DO i=1,200
        x=x+h
        CALL derivs3g(a,y,dydx,n)
        CALL rk43g(y,dydx,n,x,h,a,yout)
        y=yout
c        WRITE (*,*) x,y(1)-0.5D0*a*x**2,y(2)-a*x,y(3)-0.5D0*a*x**2,y(4)-a*x
        WRITE (*,*) x,y(1),y(2),y(3),y(4),y(5),y(6)
      END DO
      DEALLOCATE (y,yout,dydx) 
      END

      
      SUBROUTINE derivs3g(a,y,dydx,n)
      INTEGER n
      REAL(8) a,y(n),dydx(n)
      
      dydx(1)=y(2)   ! dx / dt = vx
      dydx(2)=a      ! dvx / dt = a
      dydx(3)=y(4)   ! dy / dt = vy
      dydx(4)=a      ! dvy / dt = a
      dydx(5)=y(6)   ! dz / dt = vz
      dydx(6)=a*0.5D0*y(2)      ! dvz / dt = a
      
      RETURN
      END


C -----------------------------------------------------------------------------
      SUBROUTINE rk43g(y,dydx,n,x,h,a,yout)
      
      INTEGER n,i
      REAL*8 h,x,dydx(n),y(n),yout(n),a
      REAL*8 h6,hh,xh,dym(n),dyt(n),yt(n)

      hh=h*0.5
      h6=h/6.
      xh=x+hh
      do 11 i=1,n
        yt(i)=y(i)+hh*dydx(i)
11    continue

      call derivs3g(a,yt,dyt,n)
      do 12 i=1,n
        yt(i)=y(i)+hh*dyt(i)
12    continue
      call derivs3g(a,yt,dym,n)
      do 13 i=1,n
        yt(i)=y(i)+h*dym(i)
        dym(i)=dyt(i)+dym(i)
13    continue
      call derivs3g(a,yt,dyt,n)
      do 14 i=1,n
        yout(i)=y(i)+h6*(dydx(i)+dyt(i)+2.*dym(i))
14    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *5ji6.)+.    







