


C -----------------------------------------------------------------------------
      SUBROUTINE CalRotMat(v1,v2,rotmat)
C
C     $: calculates rotation matrix
C
C -----------------------------------------------------------------------------
      REAL(8) v1(3),v2(3),rotmat(3,3)

      REAL(8) n1(3),n2(3),vs(3),v(3),vt(3)
      REAL(8) suma2, kosinus
      INTEGER i

c     normiram vektroja
      suma2=0.0D0
      DO i=1,3
        suma2=suma2+v1(i)**2
      END DO
      suma2=sqrt(suma2)
      DO i=1,3
        n1(i)=v1(i)/suma2
      END DO
      suma2=0.0D0
      DO i=1,3
        suma2=suma2+v2(i)**2
      END DO
      suma2=sqrt(suma2)
      DO i=1,3
        n2(i)=v2(i)/suma2
      END DO

c     vektorski produkt v1 x v2
      vs(1)= n1(2)*n2(3)-n1(3)*n2(2)
      vs(2)=-n1(1)*n2(3)+n1(3)*n2(1)
      vs(3)= n1(1)*n2(2)-n1(2)*n2(1)
c     normiram vs
      suma2=0.0D0
      DO i=1,3
        suma2=suma2+vs(i)**2
      END DO
      suma2=sqrt(suma2)
      DO i=1,3
        v(i)=vs(i)/suma2
      END DO
c     skalarni produkt n1 * n2
      kosinus=0.0D0
      DO i=1,3
        kosinus=kosinus+n1(i)*n2(i)
      END DO
c     skaliram
      DO i=1,3
        vt(i)=v(i) * (1.0D0 - kosinus )
      END DO

      rotMat(1,1)=vt(1) * v(1) + kosinus
      rotMat(2,2)=vt(2) * v(2) + kosinus
      rotMat(3,3)=vt(3) * v(3) + kosinus

      vt(1)=vt(1)*v(2)
      vt(3)=vt(3)*v(1)
      vt(2)=vt(2)*v(3)

      rotMat(1,2)=vt(1) - vs(3)
      rotMat(1,3)=vt(3) + vs(2)
      rotMat(2,1)=vt(1) + vs(3)
      rotMat(2,3)=vt(2) - vs(1)
      rotMat(3,1)=vt(3) - vs(2)
      rotMat(3,2)=vt(2) + vs(1)

      END

csfmatrix angleBetween(sfvec3f v1,sfvec3f v2) {
c    // turn vectors into unit vectors
c    n1 = v1.norm();
c    n2 = v2.norm();     sfvec3f vs = new sfvec3f(n1);
c    vs.cross(n2); // axis multiplied by sin sfvec3f v = new sfvec3f(vs);
c    v = v.norm(); // axis of rotation
c
c    float ca = dot(n1, n2) ; // cos angle   sfvec3f vt = new sfvec3f(v);    vt.scale((1.0f - ca);   sfmatrix rotM = new sfmatrix();
c    rotM.m11 = vt.x * v.x + ca;
c    rotM.m22 = vt.y * v.y + ca;
c    rotM.m33 = vt.z * v.z + ca; vt.x *= v.y;
c    vt.z *= v.x;
c    vt.y *= v.z;    rotM.m12 = vt.x - vs.z;
c    rotM.m13 = vt.z + vs.y;
c    rotM.m21 = vt.x + vs.z;
c    rotM.m23 = vt.y - vs.x;
c    rotM.m31 = vt.z - vs.y;
c    rotM.m32 = vt.y + vs.x;
c    return rotM;
c}



C -----------------------------------------------------------------------------
      SUBROUTINE DatumInUra(cas)
C
C     $: writes date and time to cas
C
C -----------------------------------------------------------------------------            
      CHARACTER*50 D,T,Z
      INTEGER Value(8)
      CHARACTER*39 cas     
      
      CALL DATE_AND_TIME(D,T,Z,Value)
      WRITE (cas,33) 
     &    'Date and time = ',Value(3),'.',Value(2),'.',Value(1),' ',
     &    Value(5),':',Value(6),':',Value(7),'.',Value(8)
33    FORMAT (A16,I2,A1,I2,A1,I4,A1,I2,A1,I2,A1,I2,A1,I3)

      END     


C -----------------------------------------------------------------------------
      SUBROUTINE StopProgramSingle(io,inp,ierr)
C
C     $: stops excecution of the programm
C
C -----------------------------------------------------------------------------      
c      INCLUDE 'mpif.h'
      INCLUDE 'inc_types.f'    
      TYPE(IOtype) :: io
      TYPE(InputType) :: inp
      INTEGER ierr
       
c      IF (env%myproc.EQ.1) THEN
        CALL DatumInUra(inp%endtime)
        WRITE (io%l,'(//A,A)') "START:",inp%StartTime
        WRITE (io%l,'(A,A)') "END  :",inp%EndTime        
        IF (ierr.NE.0) THEN
          WRITE (io%l,'(/A)') "Finished with an error!"
        ELSE
          WRITE (io%l,'(/A)') "Exited normally!"        
        END IF
        CLOSE(io%l)       
c      END IF
      
c      CALL MPI_FINALIZE(ierr)
      STOP
      END                 
C______________________________________________________________________C
C______________________________________________________________________C
      SUBROUTINE rOneTL(lun,OneLine)
C     _    ___ _    _ 
C     Read One Text Line 
C
C______________________________________________________________________C
C     Returns the first nonempty text line in file LUN, which does not
C     include the # character. If end of file is encoutered, it returns EOF
      CHARACTER*(*) OneLine
      INTEGER lun,i
  
10    READ(lun,'(A)',END=20) OneLine  

C     Check if line is empty
      IF (len_trim(OneLine).EQ.0) GOTO 10

C     Check if line contains # character
      DO i=1,len_trim(OneLine)
        IF (OneLine(i:i).EQ.'#') GOTO 10
      ENDDO

      RETURN

20    OneLine='EOF'
      END           
